/*
   VNC Password Dumper
   Copyright (c) 2003 Patrik Karlsson

   http://www.cqure.net

   Portions of this code are based on the pwdump2 code by Todd A. Sabin

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.
   
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
   
   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#include <windows.h>
#include <winnt.h>
#include <stdio.h>
#include <stdlib.h>

typedef unsigned long NTSTATUS;

typedef struct {
    USHORT Length;
    USHORT MaxLen;
    USHORT *Buffer;
} UNICODE_STRING;


NTSTATUS (__stdcall *NtQuerySystemInformation)(
		IN ULONG SysInfoClass,
                IN OUT PVOID SystemInformation,
                IN ULONG SystemInformationLength,
                OUT PULONG RetLen
                );

LONG (__stdcall *RtlCompareUnicodeString)(
		IN UNICODE_STRING *,
                IN UNICODE_STRING *,
                IN ULONG CaseInsensitve
                );

struct process_info {
    ULONG NextEntryDelta;
    ULONG ThreadCount;
    ULONG Reserved1[6];
    LARGE_INTEGER CreateTime;
    LARGE_INTEGER UserTime;
    LARGE_INTEGER KernelTime;
    UNICODE_STRING ProcessName;
    ULONG BasePriority;
    ULONG ProcessId;
    // etc.
};


int find_pid (DWORD *ppid, CHAR *pProcess) {

    HINSTANCE hNtDll;
    NTSTATUS rc;
    ULONG ulNeed = 0;
    void *buf = NULL;
    size_t len = 0;
    int ret = 0;
	CHAR szProcName[MAX_PATH];
    struct process_info *p = (struct process_info *)buf;

    hNtDll = LoadLibrary ("NTDLL");
    if (!hNtDll)
        return 0;

    NtQuerySystemInformation = (void*)GetProcAddress (hNtDll, "NtQuerySystemInformation");
    if (!NtQuerySystemInformation)
        return 0;

    do {
        len += 2000;
        buf = realloc (buf, len);
        if (!buf)
            return 0;
        rc = NtQuerySystemInformation (5, buf, len, &ulNeed);
    } while (rc == 0xc0000004);  // STATUS_INFO_LEN_MISMATCH

    if (rc <0) {
        free (buf);
        return 0;
    }

	p = (struct process_info *)buf;

    while ( p->NextEntryDelta != 0 ) {

		if ( p->ProcessName.Buffer != 0 )
			WideCharToMultiByte( CP_UTF8, 0, p->ProcessName.Buffer, -1, (char *)&szProcName, sizeof( szProcName ), NULL, NULL );

		if ( stricmp( szProcName, pProcess ) == 0 ) {
			*ppid = p->ProcessId;
			ret = 1;
			break;
		}

        p = (struct process_info *)(((char *)p) + p->NextEntryDelta);
    }

	if ( buf )
		free (buf);

    FreeLibrary (hNtDll);

    return ret;
}


int list_processes(char *szUsername) {

    HINSTANCE hNtDll;
	HANDLE h, hToken;
	TOKEN_USER *pUser;
	DWORD dwUserLen = 512;
    NTSTATUS rc;
    ULONG ulNeed = 0;
    void *buf = NULL;
    size_t len = 0;
    int ret = 0;
	CHAR szProcName[MAX_PATH];
    struct process_info *p = (struct process_info *)buf;
	DWORD dwLen;
	char szOwner[1024];
	DWORD dwOwnLen;
	char szDomain[1024];
	DWORD dwDomLen;
	SID_NAME_USE snuse;


    hNtDll = LoadLibrary ("NTDLL");
    if (!hNtDll)
        return 0;

    NtQuerySystemInformation = (void*)GetProcAddress (hNtDll, "NtQuerySystemInformation");
    if (!NtQuerySystemInformation)
        return 0;

    do {
        len += 2000;
        buf = realloc (buf, len);
        if (!buf)
            return 0;
        rc = NtQuerySystemInformation (5, buf, len, &ulNeed);
    } while (rc == 0xc0000004);  // STATUS_INFO_LEN_MISMATCH

    if (rc <0) {
        free (buf);
        return 0;
    }

	p = (struct process_info *)buf;

    while ( p->NextEntryDelta != 0 ) {

		if ( p->ProcessName.Buffer != 0 ) {
			WideCharToMultiByte( CP_UTF8, 0, p->ProcessName.Buffer, -1, (char *)&szProcName, sizeof( szProcName ), NULL, NULL );

			h = OpenProcess(PROCESS_QUERY_INFORMATION, FALSE, p->ProcessId );
		
			hToken = NULL;
		
			if ( h )
				OpenProcessToken(h, TOKEN_QUERY, &hToken );

			pUser = (TOKEN_USER *) malloc( dwUserLen );
			
			if ( !pUser ) {
				fprintf(stderr, "ERROR: failed to malloc %d bytes of mem\n", dwUserLen );
				exit(1);
			}
			
			if ( hToken && !GetTokenInformation( hToken, TokenUser, pUser, dwUserLen, &dwLen ) ) {
				fprintf(stderr, "ERROR: GetTokenInformation()\n");
				exit(1);
			}

			dwDomLen = sizeof( szDomain );
			dwOwnLen = sizeof( szOwner );
			LookupAccountSid( NULL, pUser->User.Sid, (char *)&szOwner, &dwOwnLen, 
								(char *)&szDomain, &dwDomLen, &snuse );

			free( pUser );

			if ( hToken )
				CloseHandle( hToken );
			
			if ( h )
				CloseHandle( h );
			
			if ( stricmp( szOwner, szUsername ) == 0 ) {
				fprintf(stdout, "found process %s\n", szProcName );
				ret = p->ProcessId;
				break;
			}			

		}

        p = (struct process_info *)(((char *)p) + p->NextEntryDelta);
    }

	if ( buf )
		free (buf);

    FreeLibrary (hNtDll);

    return ret;
}

